var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from "react";
import { useMemo } from "react";
import CategoryTable from "../category-table";
import SearchInput from "wix-storybook-utils/dist/src/ui/search-input";
import useSearchIcons from "./useSearchIcons";
import dataHooks from "../../dataHooks";
import { classes } from "./CategoryList.st.css";
// Splits icons into categories
export var mapIconsToCategories = function (iconsMetadata) {
    var categoryMap = {};
    for (var _i = 0, iconsMetadata_1 = iconsMetadata; _i < iconsMetadata_1.length; _i++) {
        var icon = iconsMetadata_1[_i];
        var _a = icon.category, category = _a === void 0 ? "Uncategorized" : _a;
        // Add category
        if (!categoryMap[category]) {
            categoryMap[category] = {
                title: category,
                iconsMetadata: [],
            };
        }
        categoryMap[category].iconsMetadata.push(icon);
    }
    return Object.values(categoryMap);
};
var CategoryList = function (_a) {
    var iconsMetadata = _a.iconsMetadata, tableHeaderTitles = _a.tableHeaderTitles, mapIconToRow = _a.mapIconToRow, searchKeys = _a.searchKeys, dataHook = _a.dataHook, className = _a.className;
    var _b = useSearchIcons(iconsMetadata, searchKeys), filteredIconsMetadata = _b.filteredIconsMetadata, debouncedSearch = _b.debouncedSearch;
    var categories = useMemo(function () { return mapIconsToCategories(filteredIconsMetadata); }, [filteredIconsMetadata]);
    return (React.createElement("div", { className: className, "data-hook": dataHook },
        React.createElement(SearchInput, { className: classes.searchInput, onChange: function (_a) {
                var value = _a.target.value;
                return debouncedSearch(value);
            }, dataHook: dataHooks.categorySearchInput }),
        categories.map(function (category) { return (React.createElement(CategoryTable, __assign({}, category, { tableHeaderTitles: tableHeaderTitles, mapIconToRow: mapIconToRow }, { key: category.title }))); })));
};
export default CategoryList;
//# sourceMappingURL=CategoryList.js.map