var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import * as React from "react";
import CategoryList from "../category-list";
import { classes } from "./GeneralCategoryListBase.st.css";
var ICON_NAME_HEADER = 'Icon Name';
var DESCRIPTION_HEADER = 'Use for';
var DEFAULT_SEARCH_KEYS = ['title', 'tags', 'aliases'];
var getHeaderTitle = function (size) { return "".concat(size, "x").concat(size); };
var getSearchKey = function (size) { return "sizes.".concat(size); };
var GeneralCategoryListBase = function (_a) {
    var iconComponents = _a.iconComponents, iconsMetadata = _a.iconsMetadata, _b = _a.iconSizes, iconSizes = _b === void 0 ? [24, 18] : _b;
    var searchKeys = __spreadArray(__spreadArray([], DEFAULT_SEARCH_KEYS, true), iconSizes.map(function (size) { return getSearchKey(size); }), true);
    var tableHeaderTitles = __spreadArray(__spreadArray([], iconSizes.reduce(function (acc, size) {
        acc.push(getHeaderTitle(size));
        acc.push(ICON_NAME_HEADER);
        return acc;
    }, []), true), [
        DESCRIPTION_HEADER
    ], false);
    var mapIconToRow = function (_a) {
        var description = _a.description, sizes = _a.sizes;
        var row = iconSizes.reduce(function (acc, size) {
            var Icon = iconComponents[sizes[size]];
            acc.push(Icon && React.createElement(Icon, null));
            acc.push(sizes[size]);
            return acc;
        }, []);
        return __spreadArray(__spreadArray([], row, true), [description], false);
    };
    return (React.createElement(CategoryList, __assign({ className: classes.tableList, dataHook: "icon-list", iconsMetadata: iconsMetadata }, {
        tableHeaderTitles: tableHeaderTitles,
        searchKeys: searchKeys,
        mapIconToRow: mapIconToRow,
    })));
};
export default GeneralCategoryListBase;
//# sourceMappingURL=GeneralCategoryListBase.js.map