import type Fuse from 'fuse.js';
import { IconMetadata } from "../src/types";
import * as React from 'react';
/** [icon name, icon sizes, description] */
export declare type SystemTableRow = [string, React.ReactNode, string | undefined];
export declare type CategoryTableRow = Array<React.ReactNode>;
export declare type Category = {
    title: string;
    iconsMetadata: Array<IconMetadata>;
};
export declare type IconProps = React.SVGAttributes<SVGElement> & {
    size?: string | number;
};
export declare type IconDescriptor = {
    size: string;
    name: string;
    Icon: React.FC<IconProps>;
};
export declare type IconsMetadataIndex = Fuse<IconMetadata>;
export declare type GeneralCategoryListProps = {
    iconComponents: Record<string, React.FC<IconProps>>;
    iconsMetadata: Array<IconMetadata>;
    iconSizes?: Array<number>;
};
export declare type SystemCategoryListProps = {
    iconComponents: Record<string, React.FC<IconProps>>;
    iconsMetadata: Array<IconMetadata>;
};
