"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var metadata_1 = require("../general/metadata");
var generalIconComponents = require("../general/dist");
var metadata_2 = require("../system/metadata");
var systemIconComponents = require("../system/dist");
var getFileNames = function (iconsMetadata) {
    return iconsMetadata.flatMap(function (_a) {
        var sizes = _a.sizes, _b = _a.aliases, aliases = _b === void 0 ? [] : _b;
        var fileNames = __spreadArray(__spreadArray([], Object.values(sizes), true), aliases, true);
        return fileNames;
    });
};
var generalIconsWithMetadata = getFileNames(metadata_1.default);
var systemIconsWithMetadata = getFileNames(metadata_2.default);
describe("General icons metadata", function () {
    var generalIconComponentNames = Object.keys(generalIconComponents);
    // File names not included in the deprecated icons array
    var activeGeneralIcons = generalIconComponentNames.filter(function (iconName) { return !metadata_1.deprecatedGeneralIcons.includes(iconName); });
    // Checks that every non-depreacted icon file has metadata
    activeGeneralIcons.forEach(function (iconName) {
        it("".concat(iconName, " has metadata"), function () {
            expect(generalIconsWithMetadata.includes(iconName)).toBe(true);
        });
    });
    // Checks that deprecated files are not described with metadata
    metadata_1.deprecatedGeneralIcons.forEach(function (iconName) {
        it("".concat(iconName, " is deprecated"), function () {
            expect(generalIconsWithMetadata.includes(iconName)).toBe(false);
        });
    });
});
describe("System icons metadata", function () {
    var systemIconComponentNames = Object.keys(systemIconComponents);
    // File names not included in the deprecated icons array
    var activeSystemIcons = systemIconComponentNames.filter(function (iconName) { return !metadata_2.deprecatedSystemIcons.includes(iconName); });
    // Checks that every non-depreacted icon file has metadata
    activeSystemIcons.forEach(function (iconName) {
        it("".concat(iconName, " has metadata"), function () {
            expect(systemIconsWithMetadata.includes(iconName)).toBe(true);
        });
    });
    // Checks that deprecated files are not described with metadata
    metadata_2.deprecatedSystemIcons.forEach(function (iconName) {
        it("".concat(iconName, " is deprecated"), function () {
            expect(systemIconsWithMetadata.includes(iconName)).toBe(false);
        });
    });
});
//# sourceMappingURL=metadata.spec.js.map