"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapIconsToCategories = void 0;
var React = require("react");
var react_1 = require("react");
var category_table_1 = require("../category-table");
var search_input_1 = require("wix-storybook-utils/dist/src/ui/search-input");
var useSearchIcons_1 = require("./useSearchIcons");
var dataHooks_1 = require("../../dataHooks");
var CategoryList_st_css_1 = require("./CategoryList.st.css");
// Splits icons into categories
var mapIconsToCategories = function (iconsMetadata) {
    var categoryMap = {};
    for (var _i = 0, iconsMetadata_1 = iconsMetadata; _i < iconsMetadata_1.length; _i++) {
        var icon = iconsMetadata_1[_i];
        var _a = icon.category, category = _a === void 0 ? "Uncategorized" : _a;
        // Add category
        if (!categoryMap[category]) {
            categoryMap[category] = {
                title: category,
                iconsMetadata: [],
            };
        }
        categoryMap[category].iconsMetadata.push(icon);
    }
    return Object.values(categoryMap);
};
exports.mapIconsToCategories = mapIconsToCategories;
var CategoryList = function (_a) {
    var iconsMetadata = _a.iconsMetadata, tableHeaderTitles = _a.tableHeaderTitles, mapIconToRow = _a.mapIconToRow, searchKeys = _a.searchKeys, dataHook = _a.dataHook, className = _a.className;
    var _b = (0, useSearchIcons_1.default)(iconsMetadata, searchKeys), filteredIconsMetadata = _b.filteredIconsMetadata, debouncedSearch = _b.debouncedSearch;
    var categories = (0, react_1.useMemo)(function () { return (0, exports.mapIconsToCategories)(filteredIconsMetadata); }, [filteredIconsMetadata]);
    return (React.createElement("div", { className: className, "data-hook": dataHook },
        React.createElement(search_input_1.default, { className: CategoryList_st_css_1.classes.searchInput, onChange: function (_a) {
                var value = _a.target.value;
                return debouncedSearch(value);
            }, dataHook: dataHooks_1.default.categorySearchInput }),
        categories.map(function (category) { return (React.createElement(category_table_1.default, __assign({}, category, { tableHeaderTitles: tableHeaderTitles, mapIconToRow: mapIconToRow }, { key: category.title }))); })));
};
exports.default = CategoryList;
//# sourceMappingURL=CategoryList.js.map