"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fuse_js_1 = require("fuse.js");
var react_1 = require("react");
var use_debounce_1 = require("use-debounce");
/** Searches icons
 * and sets the results to state
 * returns filtered and a debounced `searchCategoryIcons`
 */
function useSearchIcons(iconsMetadata, keys) {
    var searchIndex = (0, react_1.useMemo)(function () {
        return new fuse_js_1.default(iconsMetadata, {
            keys: keys,
            threshold: 0.2,
        });
    }, [iconsMetadata, keys]);
    var _a = (0, react_1.useState)(iconsMetadata), filteredIconsMetadata = _a[0], setFilteredIconsMetadata = _a[1];
    // Debounced input callback
    var debouncedSearch = (0, use_debounce_1.useDebouncedCallback)(function (query) {
        if (!query) {
            // When query is empty reset to initial data
            setFilteredIconsMetadata(iconsMetadata);
        }
        else {
            var searchResults = searchIndex.search(query);
            var filteredIconsMetadata_1 = searchResults.map(function (_a) {
                var item = _a.item;
                return item;
            });
            setFilteredIconsMetadata(filteredIconsMetadata_1);
        }
    }, 300)[0];
    return { filteredIconsMetadata: filteredIconsMetadata, debouncedSearch: debouncedSearch };
}
exports.default = useSearchIcons;
//# sourceMappingURL=useSearchIcons.js.map